#include<iostream.h>
struct node
{
  int elem;
  node *sled;
  node *pred;
};

class Spisok
{
  private:
    node *nsp;
  public:
    Spisok() {nsp=NULL;}
    void BuiltRing ();
    void VyvodLeftRight ();
    void VyvodRightLeft ();
    void InsAfter (node*,int);
    void InsBefore (node*,int);
    void Delete (node*);
    void DelAfter (node*);
    node *SearchRing (int);
    void Ochistka();
};

void main ()
{
  Spisok A;
  node *Res;
  int el,el1;

  A.BuiltRing ();
  cout<<"  '  ': \n";
  A.VyvodLeftRight ();
  cout<<" '  ': \n";
  A.VyvodRightLeft ();
  cout<<"  ,   ";
  cout<<" : ";
  cin>>el;
  cout<<"   : ";
  cin>>el1;
  Res = A.SearchRing (el);
  if  (Res!=NULL)
    {A.InsAfter (Res,el1); A.VyvodLeftRight ();}
  else  cout<<"      !\n";
  cout<<"  ,   ";
  cout<<" : ";
  cin>>el;
  cout<<"   : ";
  cin>>el1;
  Res = A.SearchRing (el);
  if  (Res!=NULL)
    { A.InsBefore (Res,el1); A.VyvodLeftRight (); }
  else  cout<<"      !\n";

  cout<<"  ,  ";
  cout<<" : ";
  cin>>el;
  Res = A.SearchRing (el);
  if  (Res!=NULL)
    { A.Delete (Res); A.VyvodLeftRight (); }
  else  cout<<"      !\n";

  cout<<"  ,   ";
  cout<<" : ";
  cin>>el;
  Res = A.SearchRing (el);
  if  (Res!=NULL)
    { A.DelAfter (Res); A.VyvodLeftRight (); }
  else  cout<<"      !\n";
  A.Ochistka();
}

void Spisok::BuiltRing ()
//     nsp
//             .
// nsp -     .
{
  node *r;
  int el;
  //    .
  nsp = new(node);
  r = nsp; (*nsp).pred = NULL; (*nsp).sled = NULL;
  cout<<"  : \n";
  cin>>el;
  while  (el!=0)
  {
    (*r).sled = new (node);
    (*((*r).sled)).pred = r; r = (*r).sled;
    (*r).sled = NULL; (*r).elem = el;
    cin>>el;
  }
  //  -   !
  if  ((*nsp).sled!=NULL)
    { (*((*nsp).sled)).pred = r; (*r).sled = (*nsp).sled; }
  else
    cout<<"  !\n";
}

void Spisok::VyvodLeftRight ()
//     
//     "  ".
// nsp -     .
{
  node *r;

  cout<<" : ";
  if  ((*nsp).sled!=NULL)
  {
    cout<<(*((*nsp).sled)).elem<<" ";
    r = (*((*nsp).sled)).sled;
    while  (r!=(*nsp).sled)
      { cout<<(*r).elem<<" "; r = (*r).sled; }
    cout<<endl;
  }
  else cout<<"!";
}

void Spisok::VyvodRightLeft ()
//     
//     "  ".
// nsp -     .
{
  node *r;

  cout<<" : ";
  if  ((*nsp).sled!=NULL)
  {
    cout<<(*((*((*nsp).sled)).pred)).elem<<" ";
    r = (*((*((*nsp).sled)).pred)).pred;
    while  (r!=(*((*nsp).sled)).pred)
      { cout<<(*r).elem<<" "; r = (*r).pred; }
    cout<<endl;
  }
  else cout<<"!";
}

node *Spisok::SearchRing (int el)
//   el    
//                .
// nsp -     .
{
  node   *q;
  node   *p;
  node *Res;

  Res = NULL; p = nsp;
  if  ((*((*p).sled)).elem==el) Res = (*p).sled;
  else
  {
    q = (*((*p).sled)).sled;
    while  (q!=(*p).sled && Res==NULL)
      if  ((*q).elem==el) Res = q;
      else  q = (*q).sled;
  }
  return Res;
}

void Spisok::InsAfter (node *Res,int el)
//      
//    el   ,   
//   Res.
{
  node *q;

  q = new(node);
  (*q).elem = el; (*q).sled = (*Res).sled;
  (*q).pred = (*(*Res).sled).pred;
  (*(*Res).sled).pred = q; (*Res).sled = q;
}

void Spisok::InsBefore (node *Res,int el)
//      
//    el  ,   
//   Res.
// nsp -     .
{
  node *q;

  q = new(node);
  (*q).elem = el;
  (*q).sled = (*(*Res).pred).sled; (*q).pred = (*Res).pred;
  (*(*Res).pred).sled = q; (*Res).pred = q;
  if  (Res==(*nsp).sled) (*nsp).sled = q;
}

void Spisok::Delete (node *Res)
//     
// ,     Res.
// nsp -     .
{
  if  ((*Res).sled==Res)
    { (*nsp).sled = NULL; delete Res; }
  else
  {
    (*(*Res).sled).pred = (*Res).pred;
    (*(*Res).pred).sled = (*Res).sled;
    if  ((*nsp).sled==Res)
      //  ""  .
      (*nsp).sled = (*Res).sled;
    delete Res;
  }
}

void Spisok::DelAfter (node *Res)
//      ,
//     ,     
//  Res.
// nsp -     .
{
  node *q;

  if  ((*Res).sled==Res)
    { (*nsp).sled = NULL; delete Res;}
  else
  {
    q = (*Res).sled;
    (*(*(*Res).sled).sled).pred = (*(*Res).sled).pred;
    (*Res).sled = (*(*Res).sled).sled;
    if  ((*(*nsp).sled).pred==Res)
      //  ""  .
      (*nsp).sled = (*Res).sled;
    delete q;
  }
}

void Spisok::Ochistka()
{
  node *q,*q1;

  q = (*((*nsp).sled)).sled;
  q1 = (*q).sled;
  while (q1!=(*((*nsp).sled)).sled)
    { delete q; q=q1; q1=(*q1).sled; }
  delete q;
  delete nsp;
}
